/**
 * Copyright 2010 JBoss Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.amentra.brms;

import java.util.HashMap;

import javax.jms.JMSException;

import org.apache.log4j.Logger;
import org.drools.runtime.process.WorkItem;
import org.drools.runtime.process.WorkItemHandler;
import org.drools.runtime.process.WorkItemManager;

//import com.amentra.jms.JMSSender;
import com.redhat.messaging.AbstractMessageSender;
import com.redhat.messaging.JMSMessageSender;


public class SendTaskHandler implements MessageConstants, WorkItemHandler 
{
	private static final Logger logger = Logger.getLogger(SendTaskHandler.class);
	
	public void executeWorkItem(WorkItem workItem, WorkItemManager manager) 
    {    	
    	String destination = (String) workItem.getParameter("destination");
        String messageId = (String) workItem.getParameter("messageId");
        Object outgoingMessage = workItem.getParameter("outgoingMessage");
        //System.out.println("Sending message: " + outgoingMessage.toString());
        //System.out.println("destination: " + destination);
        @SuppressWarnings("unchecked")
		HashMap<String, Object> hashMap = (HashMap<String, Object>) outgoingMessage; 
        //long time = System.currentTimeMillis();
        //hashMap.put("start", time);
    	hashMap.put("messageID", messageId);
    	
	    AbstractMessageSender messageSender = JMSMessageSender.getInstance();
    	
    	try {
    		messageSender.sendMessage(destination, hashMap);
		} catch (JMSException e1) {
			logger.warn("executeWorkItem()", e1);
		}
    	
        manager.completeWorkItem(workItem.getId(), null);
    }

    public void abortWorkItem(WorkItem workItem, WorkItemManager manager) {
        // Do nothing, cannot be aborted
    }
}
